`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/04/22 22:14:48
// Design Name: 
// Module Name: fsm_setting
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`define SET_ON 1  // setting state
`define SET_OFF 0 // not setting state
`define ENABLED 1
`define DISABLED 0

module fsm_setting(
    input rst_n,
    input clk,
    input DIP_set,      // set mode DIP switch input
    output reg set_en,  // set enable
    output reg rst_set  // reset for "set" only
    );
    reg state;
    reg next_state;

// FSM state decision
always@*
    case (state)
        `SET_ON:
            if (DIP_set)
                begin
                    next_state = `SET_ON;
                    set_en = `ENABLED;
                    rst_set = 1;
                end
            else
                begin
                    next_state = `SET_OFF;
                    set_en = `DISABLED;
                    rst_set = 1;
                end
        `SET_OFF:
            if (DIP_set)
                begin
                    next_state = `SET_ON;
                    set_en = `ENABLED;
                    rst_set = 0;
                end
            else
                begin
                    next_state = `SET_OFF;
                    set_en = `DISABLED;
                    rst_set = 1;
                end
        default:
            begin
                next_state = `SET_OFF;
                set_en = `DISABLED;
                rst_set = 0;
            end
    endcase

// FSM state transition
always@(posedge clk or negedge rst_n)
    if (~rst_n)
        state <= `SET_OFF;
    else
        state <= next_state;

endmodule
